module Coins where

import Graphics.Gloss

data Coin = Coin
  { posX :: Float
  , posY :: Float     
  }

-- | Lista das moedas 
type Coins = [Coin]

-- | tamanho das moedas
coinSize :: Float
coinSize = 5

-- | desenha as moedas
drawCoins :: Coins -> Picture
drawCoins cs = pictures $ map drawCoin cs
    where
        drawCoin (Coin x y) = translate x y
                             $ color white
                             $ circleSolid coinSize

-- | gera as moedas nessa posição
genCoins :: Coins
genCoins = [Coin { posX = 180, posY = 180},
            Coin { posX = 180, posY = (-180)},
            Coin { posX = (-180), posY = 180},
            Coin { posX = (-180), posY = (-180)},
            Coin { posX = 90, posY = 90},
            Coin { posX = 90, posY = (-90)},
            Coin { posX = (-90), posY = 90},
            Coin { posX = (-90), posY = (-90)},
            Coin { posX = 180, posY = 0},
            Coin { posX = (-180), posY = 0},
            Coin { posX = 45, posY = 180},
            Coin { posX = 45, posY = (-180)},
            Coin { posX = (-45), posY = 180},
            Coin { posX = (-45), posY = (-180)}]

-- | verifica se ainda há moedas no mapa
hasCoins :: Coins -> Bool
hasCoins coins = not (null coins)